<?php
function dvg_stuf_bg_admin_form($form, $form_state) {
  $form['stuf_bg'] = array(
    '#type' => 'fieldset',
    '#title' => t('StUF-BG'),
  );
  $form['stuf_bg']['dvg_stuf_bg_sender_organization'] = array(
    '#type' => 'textfield',
    '#title' => t('Sender Organization'),
    '#default_value' => variable_get('dvg_stuf_bg_sender_organization', ''),
    '#required' => TRUE,
  );
  $form['stuf_bg']['dvg_stuf_bg_sender_application'] = array(
    '#type' => 'textfield',
    '#title' => t('Sender Application'),
    '#default_value' => variable_get('dvg_stuf_bg_sender_application', ''),
    '#required' => TRUE,
  );
  $form['stuf_bg']['dvg_stuf_bg_receiver_organization'] = array(
    '#type' => 'textfield',
    '#title' => t('Receiver Organization'),
    '#default_value' => variable_get('dvg_stuf_bg_receiver_organization', ''),
    '#required' => FALSE,
  );
  $form['stuf_bg']['dvg_stuf_bg_receiver_application'] = array(
    '#type' => 'textfield',
    '#title' => t('Receiver Application'),
    '#default_value' => variable_get('dvg_stuf_bg_receiver_application', ''),
    '#required' => TRUE,
  );
  $form['stuf_bg']['dvg_stuf_bg_receiver_administration'] = array(
    '#type' => 'textfield',
    '#title' => t('Receiver Administration'),
    '#default_value' => variable_get('dvg_stuf_bg_receiver_administration', ''),
    '#required' => FALSE,
  );
  $form['stuf_bg_natuurlijk_persoon'] = array(
    '#type' => 'fieldset',
    '#title' => t('StUF-BG NatuurlijkPersoon'),
  );
  $form['stuf_bg_natuurlijk_persoon']['dvg_stuf_bg_api_url'] = array(
    '#type' => 'textfield',
    '#title' => t('API endpoint url'),
    '#default_value' => variable_get('dvg_stuf_bg_api_url', ''),
    '#description' => t('Exclude the <code>?WSDL</code> part.'),
    '#required' => TRUE,
  );
  $form['stuf_bg_natuurlijk_persoon']['dvg_stuf_bg_api_method'] = array(
    '#type' => 'radios',
    '#title' => t('API method'),
    '#default_value' => variable_get('dvg_stuf_bg_api_method', 'vraagAntwoord'),
    '#options' => array('vraagAntwoord' => 'vraagAntwoord', 'prs' => 'prs'),
    '#description' => t('API method used by the endpoint url.'),
    '#required' => TRUE,
  );
  $form['stuf_bg_natuurlijk_persoon']['dvg_stuf_bg_api_scope'] = array(
    '#type' => 'radios',
    '#title' => t('API scope'),
    '#default_value' => variable_get('dvg_stuf_bg_api_scope', 'all'),
    '#options' => array('all' => 'alles', 'specific' => 'specifiek'),
    '#description' => t('API scope used by the endpoint url.'),
    '#required' => TRUE,
  );  
  $form['stuf_bg_gezinssituatieopadresaanvrager'] = array(
    '#type' => 'fieldset',
    '#title' => t('StUF-BG GezinssituatieOpAdresAanvrager'),
  );
  $form['stuf_bg_gezinssituatieopadresaanvrager']['dvg_stuf_bg_gezinssituatieopadresaanvrager_api_url'] = array(
    '#type' => 'textfield',
    '#title' => t('API endpoint url'),
    '#default_value' => variable_get('dvg_stuf_bg_gezinssituatieopadresaanvrager_api_url', variable_get('dvg_stuf_bg_api_url', '')),
    '#description' => t('Exclude the <code>?WSDL</code> part.'),
    '#required' => FALSE,
  );
  $form['stuf_bg_gezinssituatieopadresaanvrager']['dvg_stuf_bg_gezinssituatieopadresaanvrager_api_method'] = array(
    '#type' => 'radios',
    '#title' => t('API method'),
    '#default_value' => variable_get('dvg_stuf_bg_gezinssituatieopadresaanvrager_api_method', variable_get('dvg_stuf_bg_api_method', 'vraagAntwoord')),
    '#options' => array('vraagAntwoord' => 'vraagAntwoord', 'prs' => 'prs'),
    '#description' => t('API method used by the endpoint url.'),
    '#required' => FALSE,
  );
  $form['stuf_bg_aoa'] = array(
    '#type' => 'fieldset',
    '#title' => t('StUF-BG Adrescheck'),
  );
  $form['stuf_bg_aoa']['dvg_stuf_bg_aoa_api_url'] = array(
    '#type' => 'textfield',
    '#title' => t('API endpoint url'),
    '#default_value' => variable_get('dvg_stuf_bg_aoa_api_url', ''),
    '#description' => t('Exclude the <code>?WSDL</code> part.'),
    '#required' => FALSE,
  );


  $form['caching'] = array(
    '#type' => 'fieldset',
    '#title' => t('Caching'),
  );
  $form['caching']['dvg_stuf_bg_cache_timeout'] = array(
    '#type' => 'textfield',
    '#title' => t('Cache timout in seconds'),
    '#default_value' => variable_get('dvg_stuf_bg_cache_timeout', 3600),
    '#size' => 8,
    '#description' => t('The length the cache, in seconds, before it expires. Must be %min_timeout seconds or greater.', array('%min_timeout' => DVG_STUF_BG_CACHE_MIN_TIMEOUT)),
  );

  $form['debug'] = array(
    '#type' => 'fieldset',
    '#title' => t('Debug mode'),
  );
  $form['debug']['dvg_stuf_bg_debug_bsn'] = array(
    '#type' => 'textfield',
    '#title' => t('Debug BSN'),
    '#default_value' => variable_get('dvg_stuf_bg_debug_bsn', ''),
    '#description' => t('Debug BSN used when debug mode is on.'),
  );
  $form['debug']['dvg_stuf_bg_debug_mode'] = array(
    '#type' => 'checkbox',
    '#title' => t('Debug mode'),
    '#default_value' => variable_get('dvg_stuf_bg_debug_mode', 0),
  );

  return system_settings_form($form);
}

/**
 * Settings validation.
 */
function dvg_stuf_bg_admin_form_validate($form, &$form_state) {
  $timeout = $form_state['values']['dvg_stuf_bg_cache_timeout'];
  // Validate timeout.
  if (!is_numeric($timeout) || ((int) $timeout != $timeout) || $timeout < DVG_STUF_BG_CACHE_MIN_TIMEOUT) {
    form_set_error('dvg_stuf_bg_cache_timeout', t('The timeout must be an integer greater than %min.', array('%min' => DVG_STUF_BG_CACHE_MIN_TIMEOUT)));
  }
}
